/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
*  This file is created by: Meisam Vosoughpour
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __INTERCEPT_H
#define __INTERCEPT_H


#include <AdvancedAction.h>


#define WAIT_FOR_BALL_CYCLES 3
#define MAX_POSITIVE_DASH_CYCLES 200
#define MAX_NEGATIVE_DASH_CYCLES 5
#define MAX_GTB_POINTS_NUM 100
#define MAX_GTB_CHECKED_TIME 300


class DribbleIntercept: public AdvancedAction
{
protected:
	Command *dashCommand;

public:
	DribbleIntercept(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
};


class Intercept: public AdvancedAction
{
	int bestGTBPointNumber;
	int gtbPointsNumber;
	float gtbTime[MAX_GTB_POINTS_NUM];
	float minBallDistance[MAX_GTB_POINTS_NUM];
	float extraGTBTime[MAX_GTB_POINTS_NUM];
	float distToBegin[MAX_GTB_POINTS_NUM];
	float gtbPointWeight[MAX_GTB_POINTS_NUM];
	int gtbStatus[MAX_GTB_POINTS_NUM];
	float mainGtbTime[MAX_GTB_POINTS_NUM];
	Point gtbPoint[MAX_GTB_POINTS_NUM];
	Command *gtbCommand[MAX_GTB_POINTS_NUM];

public:
	Intercept(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
};

#endif // __INTERCEPT_H
