/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __OFFENSE_H
#define __OFFENSE_H


#include <Positioning.h>
#include <AdvancedAction.h>


#define OFFENSE_X_SIZE 20
#define OFFENSE_Y_SIZE 40
#define OFFENSE_POINTS_STEP 1.00
#define OFFENSE_X_NUM (int)(OFFENSE_X_SIZE / OFFENSE_POINTS_STEP)
#define OFFENSE_Y_NUM (int)(OFFENSE_Y_SIZE / OFFENSE_POINTS_STEP)
#define OFFENSE_POINTS_NUM (OFFENSE_X_NUM * OFFENSE_Y_NUM)

#define OFFSIDE_SURE_DIST 2
#define FASTEST_DELTA_DIST 1
#define SHOOT_WEIGHT 20
#define HOME_DIST_WEIGHT 15
#define INTERCEPT_CALC_WEIGHT 10

enum OffenseDecision
{
	OD_NONE,
	OD_GETTING_CROSS
};

class Offense: public AdvancedAction
{
protected:
/*	bool valids[OFFENSE_POINTS_NUM];
	float weights[OFFENSE_POINTS_NUM];
	unsigned offenseMax;
	Point offensePoint;
	InterceptCalculate interCalc;
	OffenseDecision offenseDecision;

	void logWeights();
	void resetWeights();
	void applyHomeWeights();
	void applyShootWeights();
	void applyInterceptCalcWeights();
	void applyOneInterceptCalcWeight(const InterceptPlayer &checkPlayer);
	unsigned getMaxWeight();
	Point getWeightPoint(unsigned num);
	OffenseDecision getOffenseDecision();

	void nonPlayOnOffense();*/

public:
	Offense(const WorldModel *worldModel);
	virtual ~Offense();

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);

	Point getHomePoint(int playerUniNum, const Library &library);
};


#endif // __OFFENSE_H
