/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __GROUP_WORKS_H
#define __GROUP_WORKS_H

#include <SayDecision.h>
#include <Positioning.h>
#include <VirtualPass.h>
#include <HeadDecision.h>

class Library;

enum WithoutBallSelection
{
	WOBS_LOOKFORBALL,
	WOBS_BLOCK,
	WOBS_INTERCEPT,
	WOBS_POSITIONING,
	WOBS_OFFENSE,
	WOBS_DEFENSE
};

class GroupWorks
{
protected:
	bool interceptSay;
	bool interceptBlock;
	unsigned interceptNum;
	unsigned lastPassHearTime;

//	unsigned requestNum;
//	unsigned lastRequestNum;
//	unsigned hearedRequestPassNum;
//	unsigned hearedRequestPassTime;
//	unsigned hearedRequestPassSender;

	const WorldModel *worldModel;

	unsigned lastSRPDribbleTime;

//	VirtualKickCalculate virtualKickCalc;

//	VirtualPass virtualPass;

	float getBlockWeight(const Point &ballStopPoint,
			const Player &player) const;
	void SpecifyOffenseDefense(WithoutBallSelection &selection) const;

public:
	GroupWorks(const WorldModel *worldModel);

	bool getChangeInterceptNumPermission() const;
	void updateInterceptNum(Library &library);
	void resetByChangePlayMode();
	void setInterceptNumByPassSay(unsigned uniNum);
	void changeInterceptNumByHear(unsigned sender, unsigned uniNum);
	void signInterceptNum(SayDecisionForm &sayForm);

	WithoutBallSelection getWithoutBallSelection(const Library &library) const;

//	void suggestPassSayManager();
//	void requestSuggestPassSayManager();

//	bool getPassSayRequestPermittion();

	void updateAfterSenseBody();

	void decide();

	// setting functions
//	void setHearedRequestPassNum(unsigned hearedRequestPassNumArg);
//	void setHearedRequestPassTime(unsigned hearedRequestPassTimeArg);
//	void setHearedRequestPassSender(unsigned hearedRequestPassNumSenderArg);

};


#endif // __GROUP_WORKS_H

