/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Mohammad Salehe
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __NON_PLAY_ON_PLAN_H
#define __NON_PLAY_ON_PLAN_H


#include <Defines.h>
#include <BodyDecision.h>
#include <NonPlayOn.h>

class NonPlayOnDecision: public BodyDecision
{
protected:

	// Return Values: 1=not kicker , 2=kicker
	int selectBallKicker(Point positions[11]);
	void selectBallKickerSay(Point positions[11], Form &form);
	int savedAdvicePlayer;
	// Return Values: 1=ready to kick , 2=wait
	int backBallChoice(int cyclesToWait = 0);
	void getCurrentHomePoints(Point positions[11], const Library &library);
	// Return Values: 0=Defense , 1=Offense
	int DefenseOffenseChoice();

public:
	NonPlayOnDecision(const WorldModel *worldModel);
	virtual ~NonPlayOnDecision();

	virtual void decide(int quickLevel, Form &form,
			const Library &library);
};


#endif // __NON_PLAY_ON_PLAN_H

