/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/


#ifndef __DEF_BREAKER_PLAN_H_
#define __DEF_BREAKER_PLAN_H_

#include <Plan.h>
#include <SRPDribblePlan.h>
#include <ShootPlan.h>
#include <PassPlan.h>

class DefBreakerPlan : public Plan
{
public:
	DefBreakerPlan(const WorldModel *wm, Form &form, const Library &library);
	~DefBreakerPlan();

	virtual void decide();

	virtual double successRate();
	virtual bool isFinished();

protected:
	SRPDribblePlan *srpDribblePlan;
	PassPlan *passPlan;
	ShootPlan *shootPlan;
	float xInTwoLastCycle, xInLastCycle;
	bool isDecide;
};

#endif // __DEF_BREAKER_PLAN_H_
