/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Darioush Jalali, Mohammad Salehe
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __GOAL_PLAN_H_
#define __GOAL_PLAN_H_

#include <Plan.h>
#include <vector>
#include <string>

class GoalPlan : public Plan
{
public:
	GoalPlan(const WorldModel *wm, Form &form, const Library &library);
	~GoalPlan();

	virtual void decide();

	virtual double successRate();
	virtual bool isFinished();

protected:
	std::vector <float> passClasses;
	void startPassPlanWithPriorities(const std::vector<float>& classes, const std::vector<std::string>& priorities, bool tryDribble = true);
	unsigned findBestShooter(std::string inPlayers);
	std::pair<float,float> getWeights(const Player * );
	float getProperAngle(float angle1, float angle2) const;
private:
	
};

#endif // __GOAL_PLAN_H_
