/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany, Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <ClearPlan.h>
#include <Logger.h>

using namespace std;

ClearPlan::ClearPlan(const WorldModel *wm, Form &form,
			const Library &library) : Plan("Clear", wm, form, library),
			basicClear(new Clear(wm)), finished(false), getVal(false)
{
}

ClearPlan::~ClearPlan()
{
	delete basicClear;
}

void ClearPlan::decide()
{
	LOG << "ClearPlan::decide" << endl;
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicClear->getValue(library) - 20;
	valSetCycle = wm->getCurCycle();
	getVal = true;
	basicClear->execute(form, library);
	finished = true;
	throw basicClear->getCommand();
}

double ClearPlan::successRate()
{
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicClear->getValue(library);
	valSetCycle = wm->getCurCycle();
	getVal = true;

	if (value == AD_ALWAYS_RUN_VALUE)
		return 1.0;
	return 0.0;
}

bool ClearPlan::isFinished()
{
	if (!wm->isBallKickable())
		return true;
	return finished;
}
