/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __PASS_PLAN_H_
#define __PASS_PLAN_H_

#include <Plan.h>

class PassPlan : public Plan
{
public:
	PassPlan::PassPlan(const WorldModel *wm, Form &form, const Library &library,
			unsigned models = BPM_ALL, unsigned number = BPN_ALL,
			float passAngleFrom = -180, float passAngleTo = +180,
			float playerAngleFrom = -180, float playerAngleTo = +180);
	~PassPlan();

	virtual void decide();

	virtual double successRate();
	virtual bool isFinished();

	void reset();
private:
	ExactPassFlag exactPass;
	bool finished, getVal;
	float value;
};

#endif // __PASS_PLAN_H_
