/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <SRPDribblePlan.h>
#include <Logger.h>

using namespace std;

SRPDribblePlan::SRPDribblePlan(const WorldModel *wm, Form &form,
		const Library &library) : Plan("SRPDribble", wm, form, library),
		basicSRPDribble(new SRPDribble(wm)), finished(false), getVal(false)
{
}

SRPDribblePlan::~SRPDribblePlan()
{
	delete basicSRPDribble;
}

void SRPDribblePlan::decide()
{
	LOG << "SRPDribblePlan::decide" << endl;
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicSRPDribble->getValue(library) - 20;
	valSetCycle = wm->getCurCycle();
	getVal = true;
	basicSRPDribble->execute(form, library);
	finished = true;
	throw basicSRPDribble->getCommand();
}

double SRPDribblePlan::successRate()
{
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicSRPDribble->getValue(library) * 1.15 + 40;
	valSetCycle = wm->getCurCycle();
	getVal = true;
	if (value < -200) return 0;
	return value / 1000 + .2;
}

bool SRPDribblePlan::isFinished()
{
	if (wm->isBallKickable()) 
		return finished;
	return true;
}

