/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <ShootPlan.h>
#include <Logger.h>

using namespace std;

ShootPlan::ShootPlan(const WorldModel *wm, Form &form, const Library &library):
		Plan("Shoot", wm, form, library), basicShoot(new Shoot(wm)), finished(false),
		getVal(false)
{
}

ShootPlan::~ShootPlan()
{
	delete basicShoot;
}

void ShootPlan::decide()
{
	LOG << "ShootPlan::decide" << endl;
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicShoot->getValue(library) - 20;
	valSetCycle = wm->getCurCycle();
	getVal = true;
	basicShoot->execute(form, library);
	finished = true;
	throw basicShoot->getCommand();
}

double ShootPlan::successRate()
{
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicShoot->getValue(library);
	valSetCycle = wm->getCurCycle();
	getVal = true;
	if (value < -200) return 0;
	return value / 1000 + .2;
}

bool ShootPlan::isFinished()
{
	if (wm->isBallKickable()) 
		return finished;
	return true;
}
