/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Mohammad Salehe
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __ADVANCED_COACH_H
#define __ADVANCED_COACH_H

#include <vector>

#include "SyncedCoach.h"
#include "CoachWorldModel.h"
#include "Task.h"
#include "Trainer.h"

class AdvancedCoach: public SyncedCoach
{
protected:
	int tasksNum;
	std::vector<Task *> tasks;
	std::vector<int> runCounts;
	std::vector<int> curCounts;
	std::vector<int> runIntervals;
	std::vector<int> curIntervals;

	int numSentFreeForm;
//	Trainer * trainer;
public:
	AdvancedCoach(int argc, char **argv);
	virtual ~AdvancedCoach();

	virtual void changePlayerType(const SExpression &exp);

	void addTask(Task *task, int runCount, int runInterval);
	virtual bool processTasks();
	void informChangePlayerType(const SExpression &exp);
};

#endif // __ADVANCED_COACH_H

