/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Mohammad Salehe
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __ASSIGNMENT_GRAPH_H
#define __ASSIGNMENT_GRAPH_H


#define BIG 1000000


class AssignmentGraph
{
private:

	int dim;
	int **weights;
	int *answerRow;
	int *answerCol;
	int *u;
	int *v;
	int answerCost;
	bool maximumFlag;
	
public:
	AssignmentGraph(int size);
	~AssignmentGraph();

	void resetWeights();
	void setWeight(int row, int col, int weight);
	int getWeight(int row,int col);
	
	void prepareMaximum();
	void prepareMinimum();

	void solve();

	int getAnswerRow(int row);
	int getAnswerCol(int col);
};

#endif // __ASSIGNMENT_GRAPH_H
