/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Darioush Jalali
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __SCENARIO_H_
#define __SCENARIO_H_

#include "Trainer.h"

class Scenario : public Trainer {

 protected:
 	bool isRunning;
 	virtual bool startCondition() = 0;
	virtual bool endCondition() = 0;
	virtual void setUp() =0 ;
	virtual void monitor() = 0;
	virtual void conclude() = 0;
	virtual void cleanUp(); //by default, issues a (recover) command for the players
 public:
 	Scenario(const CoachWorldModel * worldModel, const CoachWorldModelHistory * worldModelHistory,
            Connection* connection);
	virtual ~Scenario();
	virtual void execute (bool isTrainer = true); 
};


#endif

