/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *  and is modified by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef _ROOT_PLAN_H_
#define _ROOT_PLAN_H_

#include <GroupWorks.h>
#include <CrossPlan.h>
#include <Plan.h>

class RootPlan : public Plan
{
public:
	RootPlan(const WorldModel * wm, Form &form, const Library &library);
	virtual ~RootPlan();

	virtual double successRate();
	virtual bool isFinished();

	virtual void decide();

	virtual void senseBody(const SExpression &exp);

protected:

	CrossPlan *crossPair;
	bool iShouldRestore;
};


#endif //_ROOT_PLAN_H_
